]> Savannah Git Hosting - gnulib.git/commitdiff
execve: Add tests.
authorBruno Haible <bruno@clisp.org>
Sat, 26 Dec 2020 13:19:29 +0000 (14:19 +0100)
committerBruno Haible <bruno@clisp.org>
Sat, 26 Dec 2020 13:19:29 +0000 (14:19 +0100)
* tests/test-exec-child.c: New file.
* tests/test-execve-main.c: New file.
* tests/test-execve.sh: New file.
* modules/execve-tests: New file.

ChangeLog
modules/execve-tests [new file with mode: 0644]
tests/test-exec-child.c [new file with mode: 0644]
tests/test-execve-main.c [new file with mode: 0644]
tests/test-execve.sh [new file with mode: 0755]

index 750f67bab83160d32d535722e0ac76847fb89d4a..f6795fb9d71c99a863d98aa8bd5cf434d0912055 100644 (file)
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,5 +1,11 @@
 2020-12-26  Bruno Haible  <bruno@clisp.org>
 
+       execve: Add tests.
+       * tests/test-exec-child.c: New file.
+       * tests/test-execve-main.c: New file.
+       * tests/test-execve.sh: New file.
+       * modules/execve-tests: New file.
+
        execve: New module.
        * lib/execve.c: New file.
        * m4/execve.m4: New file.
diff --git a/modules/execve-tests b/modules/execve-tests
new file mode 100644 (file)
index 0000000..3077c5f
--- /dev/null
@@ -0,0 +1,11 @@
+Files:
+tests/test-execve.sh
+tests/test-execve-main.c
+tests/test-exec-child.c
+tests/signature.h
+
+Depends-on:
+
+Makefile.am:
+TESTS += test-execve.sh
+check_PROGRAMS += test-execve-main test-exec-child
diff --git a/tests/test-exec-child.c b/tests/test-exec-child.c
new file mode 100644 (file)
index 0000000..bbcf727
--- /dev/null
@@ -0,0 +1,41 @@
+/* Callee program for the tests of the exec*() functions.
+   Copyright (C) 2020 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, see <https://www.gnu.org/licenses/>.  */
+
+#include <config.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+
+/* Do not use any gnulib replacements, since this program should
+   link against as few libraries as possible.  */
+#undef printf
+
+int
+main (int argc, char* argv[])
+{
+  /* Print the arguments.  */
+  int i;
+  printf ("argc = %d\n", argc);
+  for (i = 1; i < argc; i++)
+    printf ("argv[%d] = |%s|\n", i, argv[i]);
+
+  /* Print a particular environment variable.  */
+  const char *var = "Hommingberg";
+  if (getenv (var) != NULL)
+    printf ("%s = |%s|\n", var, getenv (var));
+
+  return 49;
+}
diff --git a/tests/test-execve-main.c b/tests/test-execve-main.c
new file mode 100644 (file)
index 0000000..3667dd2
--- /dev/null
@@ -0,0 +1,53 @@
+/* Test of execve().
+   Copyright (C) 2020 Free Software Foundation, Inc.
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 3, or (at your option)
+   any later version.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, see <https://www.gnu.org/licenses/>.  */
+
+/* Written by Bruno Haible <bruno@clisp.org>, 2020.  */
+
+#include <config.h>
+
+/* Specification.  */
+#include <unistd.h>
+
+#include "signature.h"
+SIGNATURE_CHECK (execve, int, (const char *, char * const *, char * const *));
+
+#include <stdio.h>
+
+int
+main ()
+{
+  const char *progname = "./test-exec-child";
+  const char *env[3] = { "PATH=.", "Hommingberg=Gepardenforelle", NULL };
+  const char *argv[12] =
+    {
+      progname,
+      "abc def",
+      "abc\"def\"ghi",
+      "xyz\"",
+      "abc\\def\\ghi",
+      "xyz\\",
+      "???",
+      "***",
+      "",
+      "foo",
+      "",
+      NULL
+    };
+  execve (progname, (char * const *) argv, (char * const *) env);
+
+  perror ("execve");
+  return 1;
+}
diff --git a/tests/test-execve.sh b/tests/test-execve.sh
new file mode 100755 (executable)
index 0000000..3d7ac1c
--- /dev/null
@@ -0,0 +1,48 @@
+#!/bin/sh
+
+# Test of execve().
+#
+# Copyright (C) 2020 Free Software Foundation, Inc.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <https://www.gnu.org/licenses/>.  */
+#
+# Written by Bruno Haible <bruno@clisp.org>, 2020.
+
+${CHECKER} ./test-execve-main${EXEEXT} > test-execve.tmp
+result=$?
+test $result = 49 || exit 1
+LC_ALL=C tr -d '\r' < test-execve.tmp > test-execve.out || exit 1
+
+cat > test-execve.ok <<\EOF
+argc = 11
+argv[1] = |abc def|
+argv[2] = |abc"def"ghi|
+argv[3] = |xyz"|
+argv[4] = |abc\def\ghi|
+argv[5] = |xyz\|
+argv[6] = |???|
+argv[7] = |***|
+argv[8] = ||
+argv[9] = |foo|
+argv[10] = ||
+Hommingberg = |Gepardenforelle|
+EOF
+
+: ${DIFF=diff}
+${DIFF} test-execve.ok test-execve.out
+result=$?
+
+rm -f test-execve.tmp test-execve.out test-execve.ok
+
+exit $result